package com.jz.dmp.modules.service.projconfig;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.dmp.modules.controller.projconfig.bean.DmpComputEngineBatch;
import com.jz.dmp.modules.controller.projconfig.bean.DmpComputEngineDto;
import com.jz.dmp.modules.controller.projconfig.bean.DmpComputEngineRequest;
import com.jz.dmp.modules.model.DmpComputEngine;

/**
 * 计算引擎表服务接口
 * @author ybz
 *
 */
public interface DmpComputEngineService {

	/**条件分頁查询所有计算引擎表
	 * @param dmpComputEngineRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public PageInfoResponse<DmpComputEngineDto> findListWithPage(DmpComputEngineRequest dmpComputEngineRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件查询所有计算引擎表
	 * @param dmpComputEngineRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpComputEngineDto> findList(DmpComputEngineRequest dmpComputEngineRequest, HttpServletRequest httpRequest)throws Exception;

	

	/**新增计算引擎表
	 * @param dmpComputEngine
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpComputEngine> add(DmpComputEngine dmpComputEngine, HttpServletRequest httpRequest)throws Exception;
	
	/**主键查询计算引擎表
	 * @param engineId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpComputEngineDto> findById(Integer engineId, HttpServletRequest httpRequest)throws Exception;

	/**修改计算引擎表
	 * @param dmpComputEngine
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpComputEngine> edit(DmpComputEngine dmpComputEngine, HttpServletRequest httpRequest)throws Exception;
	
	/**新增或修改计算引擎表
	 * @param dmpComputEngine
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpComputEngine> addOrEdit(DmpComputEngine dmpComputEngine, HttpServletRequest httpRequest)throws Exception;


	/**主键删除计算引擎表
	 * @param engineId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse deleteById(Integer engineId, HttpServletRequest httpRequest)throws Exception;
	
	/**主键软删除计算引擎表
	 * @param engineId
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDeleteById(Integer engineId, HttpServletRequest httpRequest)throws Exception;
	
	/**条件删除计算引擎表
	 * @param dmpComputEngineRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse delete(DmpComputEngineRequest dmpComputEngineRequest, HttpServletRequest httpRequest)throws Exception;
	
	/**条件软删除计算引擎表
	 * @param dmpComputEngineRequest
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseResponse softDelete(DmpComputEngineRequest dmpComputEngineRequest, HttpServletRequest httpRequest)throws Exception;

	/**批量新增计算引擎表
	 * @param dmpComputEngineVo
	 * @param httpRequest
	 * @return
	 * @throws Exception
	 */
	public BaseBeanResponse<DmpComputEngineBatch> addBatch(DmpComputEngineBatch dmpComputEngineBatch, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: deleteByIds  
	* @Description: TODO(根据主键批量删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse deleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;

	/**  
	* @Title: softDeleteByIds  
	* @Description: TODO(根据主键批量软删除)  
	* @param @param idList
	* @param @param httpRequest
	* @param @return
	* @param @throws Exception    参数  
	* @return BaseResponse    返回类型  
	* @throws  
	*/ 
	public BaseResponse softDeleteByIds(List<Integer> idList, HttpServletRequest httpRequest)throws Exception;

}
